[Libreoffice-commits] .: Branch 'feature/rip-build-repo' - 2 commits - g git-hooks/commit-msg git-hooks/post-merge git-hooks/pre-commit

Jan Holesovsky kendy at kemper.freedesktop.org
Wed Nov 24 15:19:12 PST 2010


 g                    |   23 ++++++
 git-hooks/commit-msg |   62 ++++++++++++++++
 git-hooks/post-merge |   12 +++
 git-hooks/pre-commit |  187 +++++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 283 insertions(+), 1 deletion(-)

New commits:
commit f6f4ab31611d3af0fd06da94aba6203e5640f3f1
Author: Jan Holesovsky <kendy at suse.cz>
Date:   Thu Nov 25 00:13:14 2010 +0100

    git-hooks: Symlink the git hooks to the ones from git-hooks/

diff --git a/g b/g
index 246d9a4..05c0260 100755
--- a/g
+++ b/g
@@ -20,6 +20,19 @@ if [ ! -e ${CLONEDIR} ]; then mkdir -p $CLONEDIR; fi
 RAWBUILDDIR=`perl -e 'use Cwd "abs_path"; print abs_path(shift);' $0 | sed -e ' s/\/g$//'`
 if [ ! -e ${RAWBUILDDIR} ]; then mkdir -p $RAWBUILDDIR; fi
 
+# should we need to update the hooks
+function update_hooks()
+{
+    HOOKDIR="$1"
+    for H in `cd "$RAWBUILDDIR/git-hooks" ; echo *` ; do
+        HOOK=".git/hooks/$H"
+        if [ ! -x "$HOOK" -a ! -L "$HOOK" ] ; then
+            rm -f "$HOOK"
+            ln -s "$HOOKDIR/$H" "$HOOK"
+        fi
+    done
+}
+
 # extra params for some commands, like log
 EXTRA=
 COMMAND="$1"
@@ -116,13 +129,17 @@ if [ "$COMMAND" = "clone" ] ; then
     DIRS="artwork base calc components extensions extras filters
           help impress libs-core libs-extern libs-extern-sys libs-gui
           postprocess sdk testing ure writer"
+    # update hooks in the main repo too
+    ( cd "$RAWBUILDDIR" ; update_hooks "../../git-hooks" )
 fi
 for REPO in $DIRS ; do
     DIR="$CLONEDIR/$REPO"
     NAME="$REPO"
+    HOOKDIR="../../../../git-hooks"
     if [ "$REPO" = "bootstrap" ] ; then
         DIR="$RAWBUILDDIR"
         NAME="main repo"
+        HOOKDIR="../../git-hooks"
     fi
 
     if [ \( -d "$DIR" -a -d "$DIR"/.git \) -o \( "$COMMAND" = "clone" \) ] ; then
@@ -130,6 +147,7 @@ for REPO in $DIRS ; do
             # executed in a subshell
             if [ "$COMMAND" != "clone" ] ; then
                 cd "$DIR"
+                update_hooks "$HOOKDIR"
             else
                 cd "$CLONEDIR"
             fi
@@ -202,7 +220,10 @@ for REPO in $DIRS ; do
             RETURN=$?
 
             # now we can change the dir in case of clone as well
-            [ "$COMMAND" = "clone" ] && cd $DIR
+            if [ "$COMMAND" = "clone" ] ; then
+                cd $DIR
+                update_hooks "$HOOKDIR"
+            fi
 
             # update stamp if the repo changed
             NEWHEADREF=`git show-ref --head HEAD`
commit 6184287c914eb05eed7becf866494273188b3703
Author: Jan Holesovsky <kendy at suse.cz>
Date:   Wed Nov 24 23:26:28 2010 +0100

    git-hooks: Copy them from the build repo.

diff --git a/git-hooks/commit-msg b/git-hooks/commit-msg
new file mode 100755
index 0000000..d51a330
--- /dev/null
+++ b/git-hooks/commit-msg
@@ -0,0 +1,62 @@
+#!/bin/sh
+#
+# An example hook script to check the commit log message.
+# Called by git-commit with one argument, the name of the file
+# that has the commit message.  The hook should exit with non-zero
+# status after issuing an appropriate message if it wants to stop the
+# commit.  The hook is allowed to edit the commit message file.
+#
+# To enable this hook, make this file executable.
+
+# Uncomment the below to add a Signed-off-by line to the message.
+# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
+# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"
+
+# This example catches duplicate Signed-off-by lines.
+
+abort() {
+    cp $1 $1.save
+    cat >&2 <<EOF
+Commit aborted, your commit message was saved as '$1.save'.
+
+Reason: $2
+
+EOF
+    exit 1
+}
+
+test "" = "$(grep '^Signed-off-by: ' "$1" |
+	 sort | uniq -c | sed -e '/^[ 	]*1[ 	]/d')" || {
+	abort "$1" "Duplicate Signed-off-by lines."
+}
+
+# Check that the first line exists, and is not an asterisk
+
+if [ -z "`head -n 1 $1 | grep -v '^[ \t]*\*'`" ] ; then
+    abort "$1" "Please provide the general description on the first line."
+fi
+
+# ...and that it is not too long
+
+if [ "`head -n 1 $1 | wc -c`" -gt 79 ] ; then
+    abort "$1" "The first line is too long, please try to fit into 79 characters."
+fi
+
+# ...and that it does not continue on the second line
+if [ "`wc -l < $1`" -gt 1 -a -n "`head -n 2 $1 | tail -n 1 | sed 's/^#.*//'`" ] ; then
+    abort "$1" "The second line is not empty - maybe the first line continues there?"
+fi
+
+# Check that the message is not a ChangeLog-like one
+
+if [ -n "`head -n 1 $1 | grep '^[0-9]\{4\}-[0-9]\{2\}-[0-9]\{2\}.*<.*@.*>'`" ] ; then
+    abort "$1" "The commit message looks like ChangeLog, please use the git form."
+fi
+
+# Check for whitespace in front of *'s
+
+if [ -n "`grep '^[[:space:]]\+\*.*:' $1`" -a -z "`grep '^\*' $1`" ] ; then
+    abort "$1" "Please don't use whitespace in front of '* file: Description.' entries."
+fi
+
+exit 0
diff --git a/git-hooks/post-merge b/git-hooks/post-merge
new file mode 100755
index 0000000..25e62ed
--- /dev/null
+++ b/git-hooks/post-merge
@@ -0,0 +1,12 @@
+#!/bin/bash
+
+# Do not warn if there were no real merge
+git rev-parse -q --verify HEAD^2 >/dev/null || exit
+
+echo
+echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
+echo "! You probably used 'git pull' instead of 'git pull -r' !"
+echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
+echo
+echo "You can still fix it - please do 'git pull -r' now."
+echo
diff --git a/git-hooks/pre-commit b/git-hooks/pre-commit
new file mode 100755
index 0000000..253f2dd
--- /dev/null
+++ b/git-hooks/pre-commit
@@ -0,0 +1,187 @@
+#!/usr/bin/perl -w
+
+# A hook script to verify what is about to be committed.
+# Called by "git commit" with no arguments.  The hook should
+# exit with non-zero status after issuing an appropriate message
+# if it wants to stop the commit.
+
+use strict;
+use File::Temp qw/ :mktemp  /;
+use File::Copy;
+
+$ENV{LC_ALL} = "C";
+
+# attempt to fix whitespace in one file
+# $1 - file to fix
+# $2 - list of lines containing whitespace errors
+sub fix_whitespace($$) {
+    my ( $file, $lines ) = @_;
+
+    # usually we have nothing to do ;-)
+    return if ( keys( %{$lines} ) == 0 ||
+                $file eq "" ||
+                !( $file =~ /\.(c|cpp|cxx|h|hrc|hxx|idl|inl|java|map|mk|MK|pl|pm|pmk|py|sdi|sh|src|tab)/ ) );
+
+    open( IN, "$file" ) || die "Cannot open $file for reading";
+    my ( $out, $tmpfile ) = mkstemp( "/tmp/whitespace-fixing-XXXXXX" );
+
+    my $line_no = 1;
+    while ( my $line = <IN> ) {
+        if ( $lines->{$line_no} && $line =~ /^(.*[^ \t])[ \t]+$/ ) {
+            print $out "$1\n";
+        }
+        elsif ( $lines->{$line_no} && $line =~ /^[ \t]+$/ ) {
+            print $out "\n";
+        }
+        else {
+            print $out $line;
+        }
+        ++$line_no;
+    }
+    close( $out );
+    close( IN );
+
+    move( $tmpfile, $file ) or die "Cannot move '$tmpfile' to '$file'";
+
+    system( "git add $file" );
+    print "Fixed whitespace in '$file'\n";
+}
+
+# go through the patch and collect lines to fix
+sub check_and_fix_whitespace($)
+{
+    my ( $head ) = @_;
+
+    my $file = "";
+    my %lines = ();
+    my $line_no = 0;
+    my $line_max = -1;
+
+    open( IN, "git diff-index -p --no-prefix --cached $head -- |" ) || die "Cannot get git diff-index";
+    while ( my $line = <IN> ) {
+        if ( $line =~ /^\+\+\+ (.*)/ ) {
+            fix_whitespace( $file, \%lines );
+            $file = $1;
+            %lines = ();
+            $line_no = 0;
+            $line_max = -1;
+        }
+        elsif ( $line =~ /^@@ -[0-9]+,[0-9]+ \+([0-9]+),([0-9]+) @@/ ) {
+            $line_no = $1;
+            $line_max = $line_no + $2;
+        }
+        elsif ( ( $line_no < $line_max ) && ( $line =~ /^[ +]/ ) ) {
+            if ( $line =~ /^\+.*[ \t]$/ ) {
+                $lines{$line_no} = 1;
+            }
+            ++$line_no;
+        }
+    }
+    fix_whitespace( $file, \%lines );
+    close( IN );
+}
+
+# Do the work :-)
+
+# Initial commit: diff against an empty tree object
+my $against="4b825dc642cb6eb9a060e54bf8d69288fbee4904";
+if ( system( "git rev-parse --verify HEAD >/dev/null 2>&1" ) == 0 ) {
+    $against="HEAD"
+}
+
+# If you want to allow non-ascii filenames set this variable to true.
+my $allownonascii=`git config hooks.allownonascii`;
+
+# Cross platform projects tend to avoid non-ascii filenames; prevent
+# them from being added to the repository. We exploit the fact that the
+# printable range starts at the space character and ends with tilde.
+if ( $allownonascii ne "true" &&
+    # Note that the use of brackets around a tr range is ok here, (it's
+    # even required, for portability to Solaris 10's /usr/bin/tr), since
+    # the square bracket bytes happen to fall in the designated range.
+    `git diff --cached --name-only --diff-filter=A -z $against | \
+     LC_ALL=C tr -d '[ -~]\\0'` ne "" )
+{
+    print <<EOM;
+Error: Attempt to add a non-ascii file name."
+
+This can cause problems if you want to work"
+with people on other platforms."
+
+To be portable it is advisable to rename the file ..."
+
+If you know what you are doing you can disable this"
+check using:"
+
+  git config hooks.allownonascii true"
+
+EOM
+    exit( 1 );
+}
+
+# be strict about tabs - we don't want them at all, setup your editor
+# correctly ;-)
+my $err_ext = "";
+
+open( FILES, "git diff-index --cached --name-only $against |" ) || die "Cannot run git diff-index.";
+while ( my $file = <FILES> ) {
+    chomp( $file );
+    if ( $file =~ /\.(c|cpp|cxx|h|hrc|hxx|idl|inl|java|map|mk|MK|pmk|pl|pm|sdi|sh|src|tab|xcu|xml)$/) {
+        open( F, "git diff-index -p --cached $against -- '$file' |" );
+        while ( my $line = <F> ) {
+            if ( $line =~ /^\+ *\t/ ) {
+                $err_ext .= "$file\n";
+                last;
+            }
+        }
+    }
+    close( F );
+}
+close( FILES );
+
+if ( $err_ext ne "" ) {
+    print <<EOM;
+Error: Your change in the following files introduces tabs in indentation:
+
+$err_ext
+Please setup your editor not to use tabs, fix the files, and try again.
+We have had enough trouble with tabs in the past :-(
+
+EOM
+    exit( 1 );
+}
+
+# check for old licenses
+my $check_licenses='^+.*\(Sun Industry Standards Source License Version\|GNU Lesser General Public License Version 2.1\)';
+my $err_licenses=`git diff-index --cached --name-only $against | while read FILE ; do \
+                      if git diff-index -p --cached $against -- "\$FILE" | grep -qs "$check_licenses" ; then \
+                          echo "\$FILE" \
+                      fi \
+                  done`;
+chomp( $err_licenses );
+if ( $err_licenses ne "" && $err_licenses ne "git-hooks/pre-commit" ) {
+    print <<EOM;
+Error: Your change in the following files introduces old licenses:
+
+$err_licenses
+
+Please check with the author(s) that they agree with upgrading the
+license to LGPL3, and change the license accondingly.
+
+EOM
+    exit( 1 );
+}
+
+# fix whitespace in code
+check_and_fix_whitespace( $against );
+
+# check the rest of the files
+my $filter_patches=`git diff-index --check --cached $against -- | sed '/\.\(diff\|patch\):/,/.*/d'`;
+chomp( $filter_patches );
+if ( $filter_patches ne "" ) {
+    print "WARNING:\n\n$filter_patches\n";
+}
+
+# all OK
+exit( 0 );
+# vi:set shiftwidth=4 expandtab:


More information about the Libreoffice-commits mailing list